//
//                            3D WireFrame Rotation
//                               Jessica Lee 1996
//

import java.awt.*;
import java.applet.Applet;
import java.lang.Math;
import trig;
import quad;
import verts;


//
//  This class is the actual Cone object
//
public class Cone{
    static trig T = new trig();       
    int x=0,y=0,z=10000 * 100;         
    int xoffset=150,yoffset=150;
    int xrot=10,yrot=10,zrot=10;            
    int xrotadd=10, yrotadd=10, zrotadd=10;
    int bred=0, bgreen=0, bblue=0;
    int fred=117, fgreen=22, fblue=108;
    int len=100;
    int size=10;

    int dimpoints=0;       // initial num of segments

    int permverts[];
    verts A;
    quad face[];

    Cone (int segments, int s){
        
        int xyz[]=new int[3];
        int i,j,cntr=0;

        dimpoints = segments;
        size = s;

        permverts = new int[(dimpoints+1)*3];
        face = new quad[dimpoints];

        permverts[0]= 0;
        permverts[1]= -len*(1/10)*(10+size);
        permverts[2]= 0; 

        cntr+=3;
        for(i=0;i<dimpoints;i++){
		xyz[0] = 0;
		xyz[1] = 0;
		xyz[2] = -100;
                xyz = rotate(xyz,0,1023 - (1024/dimpoints * i),0);

                permverts[cntr] =  ((10+size)/10)*(xyz[0]/1024-1/2);
                permverts[cntr+1] = len*(1+size/6);
                permverts[cntr+2] = ((10+size)/10)*(xyz[2]/1024-1/2);
                cntr+=3;

            }


        for(j=0;j<dimpoints;j++){
                if(j==dimpoints-1)
                    face[j] = new quad(0,j+1,1,0);
                else
                    face[j] = new quad(0,j+1,j+2,0);
            }
   
        A=new verts(permverts);

     }


    int[] rotate(int in[],int xrot, int yrot, int zrot){
        int X,Y,Z;

        X=T.cost[yrot] * in[0] - T.sint[yrot] * in[2];
        Z=T.sint[yrot] * in[0] + T.cost[yrot] * in[2];

        in[0]= (T.cost[zrot] * X/1024)  + T.sint[zrot] * in[1];
        Y=T.cost[zrot] * in[1] - (T.sint[zrot] * X/1024);

        in[2]=(T.cost[xrot] * Z/1024) - (T.sint[xrot] * Y/1024);
        in[1]=(T.sint[xrot] * Z/1024) + (T.cost[xrot] * Y/1024);

        return(in);
    }


    void remove(Graphics g){
        int i;
        for(i=0;i<dimpoints;i++){
            face[i].draw(A.tempverts,g,1,bred, bgreen, bblue, bred, bgreen, bblue);
        }
    }


    public void draw(Graphics g){
        int i;

        xrot += xrotadd;
        if (xrot > 1023) xrot -= 1024;
        yrot += yrotadd;
        if (yrot > 1023) yrot -= 1024;
        zrot += zrotadd;
        if (zrot > 1023) zrot -= 1024;

        A.rotate(xrot,yrot,zrot,T);
        A.perspective(x,y,z,xoffset,yoffset);

        for(i=0;i<dimpoints;i++){
        face[i].draw(A.tempverts,g,1,fred+(i*2), fgreen+(i*2), fblue+(i*2), bred, bgreen, bblue);
        }

    }
}




