import java.awt.*;
import java.applet.Applet;
import Cone;

public class ConeMain extends Applet implements Runnable {
    int frameNumber;
    int delay;
    Thread animatorThread;
    Dimension offDimension;              // offscreen dimensions
    Image offImage;                      // offscreen buffer
    Graphics offGraphics;                // offscreen methods
    

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();

    topanel X = new topanel(this);

//
//  Init() function - sets up applet for animation
//

    public void init() {
        String str;

        setLayout(gridbag);

        c.fill = GridBagConstraints.BOTH;

        Label label1 = new Label("Polygon -- Cone",Label.CENTER);
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(label1,c);
        add(label1);

        c.weightx  = 1.0;
        c.weighty  = .7;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(X,c);
        add(X);

        X.init();


    // Sets up framerate
        str = getParameter("fps");
        int fps = (str != null) ? Integer.parseInt(str) : 20;
        delay = (fps > 0) ? (1000 / fps) : 100;



    }

//
//  start() function - runs when applet is started.
//

    public void start() {
    //Starts animation thread if one does not exist
        if (animatorThread == null) {
            animatorThread = new Thread(this);
            animatorThread.start();
        }
    }

//
//  stop() function - runs when applet is stopped.
//

    public void stop() {
        animatorThread = null;
        offImage = null;
        offGraphics = null;
    }


//
//  run() - This is the main animation loop
//

    public void run() {
        // Remember the starting time
        long startTime = System.currentTimeMillis();

        while (Thread.currentThread() == animatorThread) {

        // Display the next frame of animation.
            X.A.repaint();
        // Delay depending on how far we are behind.
            try {
                startTime += delay;
                Thread.sleep(Math.max(0,startTime-System.currentTimeMillis()));
            }
            catch (InterruptedException e) {
                break;
            }

            frameNumber++;
//            break;

        }

    }


}



class animwindow extends Canvas{
    Dimension offDimension;              // offscreen dimensions
    Image offImage;                      // offscreen buffer
    Graphics offGraphics;                // offscreen methods
        
    Cone A= new Cone(30,10);

    animwindow(){
    }

    public Dimension minumumSize(){
        return new Dimension(100,100);
    }

    public Dimension preferredSize(){
        return new Dimension(100,100);
    }


    public void paint(Graphics g) {
        Dimension d=size();
        if (offImage != null) {
            g.drawImage(offImage, 0, 0, this);
        }
    }

    public void update(Graphics g) {
        int i;
        Dimension d=size();

    // Create the offscreen buffer if one doesn't exist.
        if ( (offGraphics == null)
          || (d.width != offDimension.width)
          || (d.height != offDimension.height) ) {
            offDimension = d;
            offImage = createImage(d.width, d.height);
            offGraphics = offImage.getGraphics();        
            offGraphics.setColor(new Color(A.bred, A.bgreen, A.bblue));
            offGraphics.fillRect(0, 0, d.width, d.height); 

            A.xoffset = size().width /2 ;
            A.yoffset = size().height /2 ;

        }

	// Erase the previous image.
        A.remove(offGraphics);
        A.draw(offGraphics);
//   g.setColor(new Color(A.bred, A.bgreen, A.bblue));

    // Paint the image onto the screen.
        g.drawImage(offImage, 0, 0, this);
    }


}


class topanel extends Panel{
    animwindow A = new animwindow();
    rightpanel B;

    topanel(ConeMain parent){
        setLayout(new GridLayout(0,2,5, 10));

        add(A);

        B = new rightpanel(parent);
        add(B);
    }

    void init(){
        B.init();
    }
}

class rightpanel extends Panel{
    Scrollbar frslider = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,255);
    Scrollbar fgslider = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,255);
    Scrollbar fbslider = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,255);

    Scrollbar cross = new Scrollbar(Scrollbar.HORIZONTAL,0,1,3,60);
    Scrollbar segments = new Scrollbar(Scrollbar.HORIZONTAL,0,1,3,60);
    Scrollbar objsize = new Scrollbar(Scrollbar.HORIZONTAL,0,1,1,20);

    Scrollbar xrotslider = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);
    Scrollbar yrotslider = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);
    Scrollbar zrotslider = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();

    Button b1 = new Button("start");
    Button b2 = new Button("stop");

    TextField frfield = new TextField(2);
    TextField fgfield = new TextField(2);
    TextField fbfield = new TextField(2);

    TextField crsfield = new TextField(2);
    TextField segfield = new TextField(2);
    TextField sizefield = new TextField(2);

    TextField xfield = new TextField(2);
    TextField yfield = new TextField(2);
    TextField zfield = new TextField(2);

    ConeMain parent;

    rightpanel(ConeMain parent){

        rightpanel.parent = parent;

        setLayout(gridbag);

        c.fill = GridBagConstraints.BOTH;

        c.weightx  = 0.5;
        c.weighty  = 0.2;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(b1,c);
        b1.disable();
        add(b1);
        
        c.weightx = 0.5;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(b2,c);
        add(b2);


        Label label1 = new Label("Object:            Red",Label.LEFT);
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(label1,c);
        add(label1);

        c.weightx = 0.8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(frslider,c);
        add(frslider);

        c.weightx = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(frfield,c);
        add(frfield);

        Label label2 = new Label("Green",Label.CENTER);
        gridbag.setConstraints(label2,c);
        add(label2);

        c.weightx = .8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(fgslider,c);
        add(fgslider);

        c.weightx = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(fgfield,c);
        add(fgfield);

        Label label3 = new Label("Blue",Label.CENTER);
        gridbag.setConstraints(label3,c);
        add(label3);

        c.weightx = .8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(fbslider,c);
        add(fbslider);

        c.weightx = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(fbfield,c);
        add(fbfield);


        Label label4 = new Label("X Rotation Speed",Label.CENTER);
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(label4,c);
        add(label4);

        c.weightx = 0.8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(xrotslider,c);
        add(xrotslider);

        c.weightx = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(xfield,c);
        add(xfield);

        Label label5 = new Label("Y Rotation Speed",Label.CENTER);
        gridbag.setConstraints(label5,c);
        add(label5);

        c.weightx = .8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(yrotslider,c);
        add(yrotslider);

        c.weightx = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(yfield,c);
        add(yfield);

        Label label6 = new Label("Z Rotation Speed",Label.CENTER);
        gridbag.setConstraints(label6,c);
        add(label6);

        c.weightx = .8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(zrotslider,c);
        add(zrotslider);

        c.weightx = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(zfield,c);
        add(zfield);

        Label label7 = new Label("Size of the Object",Label.CENTER);
        gridbag.setConstraints(label7,c);
        add(label7);

        c.weightx  = 0.8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(objsize,c);
        add(objsize);

        c.weightx  = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(sizefield,c);
        add(sizefield);

        Label label8 = new Label("Number of segments",Label.CENTER);
        gridbag.setConstraints(label8,c);
        add(label8);

        c.weightx  = 0.8;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(segments,c);
        add(segments);

        c.weightx  = 0.2;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(segfield,c);
        add(segfield);




    }

    void init(){
        sizefield.setText(String.valueOf(parent.X.A.A.size));
        objsize.setValue(parent.X.A.A.size);

        segfield.setText(String.valueOf(parent.X.A.A.dimpoints));
        segments.setValue(parent.X.A.A.dimpoints);

        frfield.setText(String.valueOf(parent.X.A.A.fred));
        frslider.setValue(parent.X.A.A.fred);

        fgfield.setText(String.valueOf(parent.X.A.A.fgreen));
        fgslider.setValue(parent.X.A.A.fgreen);

        fbfield.setText(String.valueOf(parent.X.A.A.fblue));
        fbslider.setValue(parent.X.A.A.fblue);

        xfield.setText(String.valueOf(parent.X.A.A.xrotadd));
        xrotslider.setValue(parent.X.A.A.xrotadd);

        yfield.setText(String.valueOf(parent.X.A.A.yrotadd));
        yrotslider.setValue(parent.X.A.A.yrotadd);

        zfield.setText(String.valueOf(parent.X.A.A.zrotadd));
        zrotslider.setValue(parent.X.A.A.zrotadd);

    }

    public boolean handleEvent(Event e){
        if(e.id == Event.ACTION_EVENT){
            if (e.target == b1){
                b1.disable();
                b2.enable();
                parent.start();
            }
            if(e.target == b2){
                b2.disable();
                b1.enable();
                parent.stop();
            }
        }

        if(e.target == frslider){
            frfield.setText(String.valueOf(frslider.getValue()));
            parent.X.A.A.fred = frslider.getValue(); 
        }
        if(e.target == frfield && e.id == Event.ACTION_EVENT){
            frslider.setValue(Integer.valueOf(frfield.getText()).intValue());
            frfield.setText(String.valueOf(frslider.getValue()));
            parent.X.A.A.fred = frslider.getValue();
        }
        if(e.target == fgslider){
            fgfield.setText(String.valueOf(fgslider.getValue()));
            parent.X.A.A.fgreen = fgslider.getValue();
        }
        if(e.target == fgfield && e.id == Event.ACTION_EVENT){
            fgslider.setValue(Integer.valueOf(fgfield.getText()).intValue());
            fgfield.setText(String.valueOf(fgslider.getValue()));
            parent.X.A.A.fgreen = fgslider.getValue();
        }
        if(e.target == fbslider){
            fbfield.setText(String.valueOf(fbslider.getValue()));
            parent.X.A.A.fblue = fbslider.getValue();
        }
        if(e.target == fbfield && e.id == Event.ACTION_EVENT){
            fbslider.setValue(Integer.valueOf(fbfield.getText()).intValue());
            fbfield.setText(String.valueOf(fbslider.getValue()));
            parent.X.A.A.fblue = fbslider.getValue();
        }

        if(e.target == objsize){
            sizefield.setText(String.valueOf(objsize.getValue()));
        new_setting();
        }
        if(e.target == sizefield && e.id == Event.ACTION_EVENT){
            objsize.setValue(Integer.valueOf(sizefield.getText()).intValue());
            sizefield.setText(String.valueOf(objsize.getValue()));
           new_setting();
        }
        if(e.target == segments){
            segfield.setText(String.valueOf(segments.getValue()));
           new_setting();
        }
        if(e.target == segfield && e.id == Event.ACTION_EVENT){
            segments.setValue(Integer.valueOf(segfield.getText()).intValue());
            segfield.setText(String.valueOf(segments.getValue()));
         new_setting();
        }



        if(e.target == xrotslider){
            xfield.setText(String.valueOf(xrotslider.getValue()));
            parent.X.A.A.xrotadd = xrotslider.getValue();
        }
        if(e.target == xfield && e.id == Event.ACTION_EVENT){
            xrotslider.setValue(Integer.valueOf(xfield.getText()).intValue());
            xfield.setText(String.valueOf(xrotslider.getValue()));
            parent.X.A.A.xrotadd = xrotslider.getValue();
        }
        if(e.target == yrotslider){
            yfield.setText(String.valueOf(yrotslider.getValue()));
            parent.X.A.A.yrotadd = yrotslider.getValue();
        }
        if(e.target == yfield && e.id == Event.ACTION_EVENT){
            yrotslider.setValue(Integer.valueOf(yfield.getText()).intValue());
            yfield.setText(String.valueOf(yrotslider.getValue()));
            parent.X.A.A.yrotadd = yrotslider.getValue();
        }
        if(e.target == zrotslider){
            zfield.setText(String.valueOf(zrotslider.getValue()));
            parent.X.A.A.zrotadd = zrotslider.getValue();
        }
        if(e.target == zfield && e.id == Event.ACTION_EVENT){
            zrotslider.setValue(Integer.valueOf(zfield.getText()).intValue());
            zfield.setText(String.valueOf(zrotslider.getValue()));
            parent.X.A.A.zrotadd = zrotslider.getValue();
        }



        return super.handleEvent(e);
    }




    void new_setting(){
        int xra, yra, zra;
        int xr, yr, zr;
        int br0, bg0, bb0;
        int br1, bg1, bb1;
        int fr0, fg0, fb0;
        int fr1, fg1, fb1;

        fr0 = parent.X.A.A.fred;
        fg0 = parent.X.A.A.fgreen;
        fb0 = parent.X.A.A.fblue;

        xra = parent.X.A.A.xrotadd;
        yra = parent.X.A.A.yrotadd;
        zra = parent.X.A.A.zrotadd;

        xr = parent.X.A.A.xrot;
        yr = parent.X.A.A.yrot;
        zr = parent.X.A.A.zrot;

        parent.X.A.A.remove(parent.X.A.offGraphics);
 
        parent.X.A.A = new Cone(segments.getValue(),objsize.getValue());
        parent.X.A.A.xoffset = parent.X.A.size().width /2 ;
        parent.X.A.A.yoffset = parent.X.A.size().height /2 ;

        parent.X.A.A.fred = fr0;
        parent.X.A.A.fgreen = fg0;
        parent.X.A.A.fblue = fb0;

        parent.X.A.A.xrotadd = xra;
        parent.X.A.A.yrotadd = yra;
        parent.X.A.A.zrotadd = zra;

        parent.X.A.A.xrot = xr;
        parent.X.A.A.yrot = yr;
        parent.X.A.A.zrot = zr;
    }

}




