//
//                            3D WireFrame Rotation
//                               Jessica Lee
//

import java.awt.*;
import java.applet.Applet;
import java.lang.Math;
import quad;
import verts;
import trig;



//
//  This class is the Cylinder object
//
public class Cylinder{
    static trig T = new trig();              
    int x=0,y=0,z=10000 * 100;               
    int xoffset=150,yoffset=150;
    int xrot=10,yrot=10,zrot=10;            
    int xrotadd=10, yrotadd=10, zrotadd=10;
    int bred=0, bgreen=0, bblue=0;
    int fred=162, fgreen=70, fblue=147;

    int dimpoints=0;       // initial num of segments
    int size;

    int permverts[];
    verts A;
    int len = 100;
    quad face[];

    Cylinder (int segments, int s){
        int xyz[]=new int[3];
        int i,j,cntr=0;

        dimpoints = segments;
        size = s;
        permverts = new int[dimpoints*3*2];
        face = new quad[dimpoints];


        for(i=0;i<dimpoints;i++){
		xyz[0] = 0;
		xyz[1] = 0;
		xyz[2] = -100;
                xyz = rotate(xyz,0,1023 - (1024/dimpoints * i),0);

                permverts[cntr] =  (1+size/6)*(xyz[0]/1024-1/2);
                permverts[cntr+1] = (10+size)*(len/10);
                permverts[cntr+2] = (1+size/6)*(xyz[2]/1024-1/2);
                permverts[cntr+3] =  (1+size/6)*(xyz[0]/1024-1/2);
                permverts[cntr+4] = -(10+size)*(len/10);
                permverts[cntr+5] = (1+size/6)*(xyz[2]/1024-1/2);
 
                cntr+=6;

            }


        for(j=0;j<(dimpoints*2)-1;j+=2){
                if(j==dimpoints*2-2)
                    face[j/2] = new quad(j,j+1,1,0);
                else
                    face[j/2] = new quad(j,j+1, j+3,j+2);
            }
   
        A=new verts(permverts);

     }


    int[] rotate(int in[],int xrot, int yrot, int zrot){
        int X,Y,Z;

        X=T.cost[yrot] * in[0] - T.sint[yrot] * in[2];
        Z=T.sint[yrot] * in[0] + T.cost[yrot] * in[2];

        in[0]= (T.cost[zrot] * X/1024)  + T.sint[zrot] * in[1];
        Y=T.cost[zrot] * in[1] - (T.sint[zrot] * X/1024);

        in[2]=(T.cost[xrot] * Z/1024) - (T.sint[xrot] * Y/1024);
        in[1]=(T.sint[xrot] * Z/1024) + (T.cost[xrot] * Y/1024);

        return(in);
    }


    void remove(Graphics g){
        int i;
        for(i=0;i<dimpoints;i++){
        face[i].draw(A.tempverts,g,1,bred, bgreen, bblue, bred, bgreen, bblue);
        }
    }


    public void draw(Graphics g){
        int i,j;

        xrot += xrotadd;
        if (xrot > 1023) xrot -= 1024;
        yrot += yrotadd;
        if (yrot > 1023) yrot -= 1024;
        zrot += zrotadd;
        if (zrot > 1023) zrot -= 1024;

        A.rotate(xrot,yrot,zrot,T);
        A.perspective(x,y,z,xoffset,yoffset);

        for(i=0;i<dimpoints;i++){
        j =dimpoints/2;
        if (i<j)
        face[i].draw(A.tempverts,g,1,fred+((j-i)*2), fgreen+((j-i)*2), fblue+((j-i)*2), bred, bgreen, bblue); 
        if (i>j)
        face[i].draw(A.tempverts,g,1,fred+((i-j)*2), fgreen+((i-j)*2), fblue+((i-j)*2), bred, bgreen, bblue);
        if (!(i>j || i<j))
        face[i].draw(A.tempverts,g,1,fred, fgreen, fblue, bred, bgreen, bblue);
        }
    }
}




