//
//                            3D WireFrame Rotation
//                               Jessica Lee
//
import java.awt.*;
import java.applet.Applet;
import java.lang.Math;
import java.lang.Number;
import quad;
import trig;
import verts;


//
//  This class is the Torus object
//
public class Torus{
    static trig T = new trig();        
    int x=0,y=0,z=10000 *100;          
    int xoffset=150,yoffset=150;
    int xrot=10,yrot=10,zrot=10;         
    int xrotadd=10, yrotadd=10, zrotadd=10;
    int size=2;
    int bred=0, bgreen=0, bblue=0;
    int fred=20, fgreen=20, fblue=100;

    int radpoints=16;              // initial num of cross sectional points
    int dimpoints=8;               // initial num of segments

    int permverts[];
    verts A;
    int radius = 200;
    quad face[];

    Torus (int cross, int segments, int s){
        int xyz[] =new int[3];
        int i,j,cntr=0;

        size = s;
        radpoints = cross;
        dimpoints = segments;

        permverts = new int[radpoints * dimpoints * 3];
        face = new quad[radpoints * dimpoints];

        for(i=0;i<dimpoints;i++){
            for(j=0;j<radpoints;j++){
                xyz[0]=0;
                xyz[1]=0;
                xyz[2]=-100;

                xyz = rotate(xyz,1023 - (1024/radpoints * j),0,0);
                xyz[1] += radius*1024;
                xyz[0]/=1024;
                xyz[1]/=1024;
                xyz[2]/=1024;

                xyz = rotate(xyz,0,0,1023 - (1024/dimpoints * i));
                permverts[cntr] = (1+size/6)*xyz[0]/(1024*3);
                permverts[cntr+1] = (1+size/6)*xyz[1]/(1024*3);
                permverts[cntr+2] = (1+size/6)*xyz[2]/(1024*3);

                cntr+=3;

            }
        }

        cntr=0;
        for(j=0;j<dimpoints-1;j++){
            for(i=0;i<radpoints;i++){
                if(i==radpoints-1)
                    face[cntr+i] = new quad(cntr+i,cntr+0,cntr+radpoints,cntr+i+radpoints);
                else
                    face[cntr+i] = new quad(cntr+i,cntr+i+1,cntr+i+radpoints+1,cntr+i+radpoints);
            }
            cntr+=radpoints;
        }

        for(i=0;i<radpoints;i++){
            if(i==radpoints-1)
                face[cntr+i] = new quad(cntr+i,cntr+(0),0,radpoints-1);
            else
                face[cntr+i] = new quad(cntr+i,cntr+(i+1),(i+1),(i));
        }



        A=new verts(permverts);
    }

    int[] rotate(int in[],int xrot, int yrot, int zrot){
        int X,Y,Z;

        X=T.cost[yrot] * in[0] - T.sint[yrot] * in[2];
        Z=T.sint[yrot] * in[0] + T.cost[yrot] * in[2];

        in[0]= (T.cost[zrot] * X/1024)  + T.sint[zrot] * in[1];
        Y=T.cost[zrot] * in[1] - (T.sint[zrot] * X/1024);

        in[2]=(T.cost[xrot] * Z/1024) - (T.sint[xrot] * Y/1024);
        in[1]=(T.sint[xrot] * Z/1024) + (T.cost[xrot] * Y/1024);

        return(in);
    }

    void remove(Graphics g){
      int i;
      for(i=0;i<dimpoints*radpoints;i++){
        face[i].draw(A.tempverts,g,1,bred, bgreen, bblue, bred, bgreen, bblue);
        }
    }

    public void draw(Graphics g){
        int i;

        xrot += xrotadd;
        if (xrot > 1023) xrot -= 1024;
        yrot += yrotadd;
        if (yrot > 1023) yrot -= 1024;
        zrot += zrotadd;
        if (zrot > 1023) zrot -= 1024;

        A.rotate(xrot,yrot,zrot,T);
        A.perspective(x,y,z,xoffset,yoffset);

        for(i=0;i<dimpoints*radpoints;i++){
        face[i].draw(A.tempverts,g,1,fred+(i*2), fgreen+(i*2), fblue+(i*2), bred, bgreen, bblue);
        }

    }
}


